/**
* General Purpose Mapper
*/
package owrti;

import java.util.*;

public class GlbNaming implements RTIDebug {

   protected Hashtable idToName = new Hashtable();
   protected Hashtable nameToId = new Hashtable();
   protected Hashtable idToRec = new Hashtable();
   private   Object    recLock = new Object();

   /** */
   public GlbNaming() {}

   /** */
   public String getName(Object key) { return (String) idToName.get(key); }

   /** */
   public Object getID(String key) { return nameToId.get(key); }

   /** */
   public Object getRecord(Object key) { return idToRec.get(key); }

   /** */
   public int getSize() { return idToRec.size(); }

   /** */
   public final void addEntry(Object handle, String name, Object record) { 
      synchronized(recLock) {
        nameToId.put(name,handle); 
        idToName.put(handle,name); 
        idToRec.put(handle,record); 
      }// end of synchronized 
   }// end of addEntry()

   /**
   */
   public final void removeEntry(Object handle) { 
      String name = (String) idToName.get(handle);
      synchronized(recLock) {
        if(name != null ) nameToId.remove(name);
        idToName.remove(handle);
        idToRec.remove(handle);
      }// end of synchronized 
   }// end of removeEntry()

   /**
   */
   public final void removeEntry(String name) { 
      Object id = nameToId.get(name);
      if(id != null ) 
        synchronized(recLock) {
         nameToId.remove(name);
         idToName.remove(id);
         idToRec.remove(id);
        }// end of synchronized
   }// end of removeEntry()

}// end of class GlbNaming
