/**
*
*/
package owrti;
import RTIcap.*;
/**
*/
public class InteractionNaming extends GlbNaming implements RTIDebug {

   /** */
   public InteractionNaming() { }

   /**
   */
   public short getInteractionClassHandle(String theName)
          throws RTIcap.NameNotFound, RTIcap.FederateNotExecutionMember, 
                 RTIcap.RTIinternalError 
    {  
       String lookUpName = theName;
       if(lookUpName.startsWith("interactionroot."))
              lookUpName = "interactionRoot."+theName.substring(16,theName.length());
       else
          if(!lookUpName.startsWith("interactionRoot."))
              lookUpName = "interactionRoot."+theName;

       if(DEBUG) System.out.println("in  getInteractionClassHandle("+lookUpName+")");

       Short ret = (Short) getID(lookUpName);

       if(ret==null) throw new RTIcap.NameNotFound();

       if(DEBUG) System.out.println("out of getInteractionClassHandle("+theName+")");

       return ret.shortValue();

    }// end of getInteractionClassHandle()

    /**
    */
    public String 
    getInteractionClassName(short theHandle)
           throws RTIcap.InteractionClassNotDefined, 
                  RTIcap.FederateNotExecutionMember, RTIcap.RTIinternalError 
    {
       if(DEBUG) System.out.println("in  getInteractionClassName("+theHandle+")");
       String ret = (String) getName(new Short(theHandle));

       if(ret==null) throw new RTIcap.InteractionClassNotDefined();

       if(DEBUG) System.out.println("out of getInteractionClassName("+theHandle+")");
       return ret;

    }// end of getInteractionClassName()

    /**
    */
    public short 
    getParameterHandle(String theName, short whichClass)
          throws RTIcap.InteractionClassNotDefined, RTIcap.NameNotFound, 
                 RTIcap.FederateNotExecutionMember, RTIcap.RTIinternalError 
    {
       if(DEBUG) System.out.println("in  getParameterHandle("+theName+")");

       InteractionRecord rec = (InteractionRecord) getRecord(new Short(whichClass)); 
  
       if(rec==null) throw new RTIcap.InteractionClassNotDefined();

       if(DEBUG) System.out.println("out of getParameterHandle("+theName+")");

       return rec.getParameterHandle(theName);

    }// end of getParameterHandle()

    /**
    */
    public String 
    getParameterName(short theHandle, short whichClass)
           throws RTIcap.InteractionClassNotDefined, 
                  RTIcap.InteractionParameterNotDefined, 
                  RTIcap.FederateNotExecutionMember, RTIcap.RTIinternalError 
    {
       InteractionRecord rec = (InteractionRecord) getRecord(new Short(whichClass)); 
  
       if(rec==null) throw new RTIcap.InteractionClassNotDefined();

       return rec.getParameterName(theHandle);

    }// end of getParameterName()

    /**
    */
    public InteractionRecord getInteractionRecord(short theInteraction)
                      throws RTIcap.InteractionClassNotDefined {
       InteractionRecord rec = (InteractionRecord) getRecord(new Short(theInteraction)); 
  
       if(rec==null) {   
          if(DEBUG) System.out.println(theInteraction+"th interaction does not exist!");
          throw new RTIcap.InteractionClassNotDefined();
       }
   
       return rec;

    }// end of getInteractionRecord()

    /** */
    public void addInteractionRecord(InteractionRecord rec) {
       addEntry(new Short(rec.getId()),rec.getName(),rec);
    }// end of getInteractionRecord()

}// end of class InteractionNaming

