package owrti;
import RTIcap.*;
/*
* Defines the RTI Services 
*/
public class ParameterNaming extends GlbNaming implements RTIDebug {
    InteractionRecord father;

    /** */
    public ParameterNaming(InteractionRecord _boss) { father = _boss; }

    /** */
    public short getParameterHandle(String theName) throws RTIcap.NameNotFound {
       if(DEBUG) System.out.println(" in getParameterHandle("+theName+")");
       Short ret= (Short) getID(theName);
       if(ret==null) throw new RTIcap.NameNotFound();
       if(DEBUG) System.out.println(" out of getParameterHandle("+theName+")");
       return ret.shortValue();
    }// end of getParameterHandle()

    /** */
    public String 
    getParameterName(short theHandle) throws RTIcap.InteractionParameterNotDefined 
    {
       String ret = (String) getName(new Short(theHandle));
       if(ret==null) throw new RTIcap.InteractionParameterNotDefined();
       return ret;
    }// end of getParameterName()

    /** 
    public short addParameter(String theName) {
       short ret = (short) (idToName.size()+1);
       idToName.put(new Short(ret),theName);
       nameToId.put(theName,new Short(ret));
       idToParamInfo.put(new Short(ret),new ParameterInfo(ret,theName,RTIcap.TransportType.RELIABLE,RTIcap.OrderType.RECEIVE));
       return ret;
    }// end of addParameter()
    */

    /** */ 
    public short addParameter(String theName) {
       short ret = (short) (getSize()+1);
       addEntry(new Short(ret),theName,new ParameterInfo(ret,theName,RTIcap.TransportType.RELIABLE,RTIcap.OrderType.RECEIVE));
       return ret;
    }// end of addParameter()

    /** */
    public ParameterInfo getParameterInfo(short theHandle) {
       return (ParameterInfo) getRecord(new Short(theHandle));
    }// end of getParameterInfo()

    /** */
    public int getNumberOfParameters() { return getSize(); }

    /** */
    public boolean contains(short theHandle) {
       return ( getName(new Short(theHandle))!=null );
    }// end of contains()

    /** */
    public boolean contains(String theName) {
       return ( getID(theName)!=null );
    }// end of contains()

}// end of ParameterNaming



