package owrti;
import java.util.Vector;
import java.util.Hashtable;
/** */
public class PublisherRegistry implements RTIDebug {
   Vector     publishers  = new Vector();
   Hashtable  fpublishers = new Hashtable(); 
   Object publishersLock  = new Object();
   Object fpublishersLock = new Object();

   /** */
   public PublisherRegistry() { }

   /** */
   public final void addFederate(short f) {  
    if(!publishers.contains(new Short(f))) 
       synchronized(publishersLock) { publishers.addElement(new Short(f)); }
   }// end of addFederate()

   /** */
   public final void removeFederate(short f) {  
    if(publishers.contains(new Short(f))) 
       synchronized(publishersLock) { publishers.removeElement(new Short(f)); }
   }// end of removeFederate()

   /** */
   public final void addFederate(FederateInfo f) {  
    if(!publishers.contains(new Short(f.getFederateID()))) { 
      addFederate(f.getFederateID());
      synchronized(fpublishersLock) { fpublishers.put(new Short(f.getFederateID()),f); }
    }//end of if 
   }// end of addFederate()

   /** */
   public final void removeFederate(FederateInfo f) {  
    if(publishers.contains(new Short(f.getFederateID()))) {
      removeFederate(f.getFederateID());
      synchronized(fpublishersLock) { fpublishers.remove(new Short(f.getFederateID())); }
    }// end of if
   }// end of removeFederate()

   /** */
   public final FederateInfo getFederateInfo(short f) {  
      return (FederateInfo)fpublishers.get(new Short(f));
   }// end of removeFederate()

   /** */
   public final boolean canPublish(short f) {  
    return publishers.contains(new Short(f)); 
   }// end of canPublish()

}// end of class PublisherRegistry

