package owrti;
import java.util.Vector;

public class RTIMsgDispatcher extends Thread implements RTIMessageDispatcher {
   Vector  msgVect;
   Object  msgVectLock = new Object();

   public RTIMsgDispatcher() { setPriority(Thread.NORM_PRIORITY-1); start(); }

   public synchronized void run() {
     if(msgVect==null) msgVect = new Vector();
     try
     { while(true) {
         while(msgVect.size()==0) wait();
         RTIMessage newMsg=null;
         synchronized(msgVectLock) 
         { newMsg= (RTIMessage)msgVect.elementAt(0); msgVect.removeElementAt(0); };
         if(newMsg!=null) 
         { try{ newMsg.execute(); } catch(Exception e) {}; newMsg=null; }
       }// end of while()
     } catch(InterruptedException ex) {}
   }// end of run()

   public synchronized void addRTIMsg(RTIMessage newMsg) { 
      if(msgVect==null) msgVect = new Vector();
      synchronized(msgVectLock) { msgVect.addElement(newMsg); }
      notify(); 
   }// end of addRTIMsg()

}// end of class RTIMsgDispatcher
