package owrti.evt;
import owrti.*;
import RTIcap.*;

/**
* 
* @date April 22, 1998 ( Updated at April 22, 1998 )
* @author H. Timucin Ozdemir
* 
*/
public class EvtAttributeOwnershipAcquisitionNotification implements RTIEvent, RTIDebug 
{

   double timeStamp;
   int    ObjectID;
   short[] attribs;

   /** */
   public EvtAttributeOwnershipAcquisitionNotification( int _ObjectID, short[] _att)
   {
      ObjectID = _ObjectID;
       attribs = _att;
   }// end of CONSTRUCTOR
   
   /** */
   public double getTimeStamp() {  return timeStamp; }

   /** */
   public void execute(RTIcap.FederateAmbassador fed) {
      try
      { fed.attributeOwnershipAcquisitionNotification(ObjectID,attribs);
      } catch( RTIcap.ObjectNotKnown e1) {}
        catch( RTIcap.AttributeNotKnown e2) {}
        catch( RTIcap.AttributeAcquisitionWasNotRequested e3) {}
        catch( RTIcap.AttributeAlreadyOwned e4) {}
        catch( RTIcap.AttributeNotPublished e5) {}
        catch( RTIcap.FederateInternalError e6) {}
        catch( Exception e) {}
   }// end of execute()

   /**
   */
   public final String toString() {
      String ret = new String(" attributeOwnershipAcqusitionNotification oID : "+ObjectID);
      if(attribs.length>0) {
         ret += (" a: "+attribs[0]);
         for(int i=1;i<attribs.length;i++) ret += (","+attribs[i]);
      }// end of if

      ret += (" @ "+timeStamp);

      return ret;

   }// end of toString() 

}// end of class EvtAttributeOwnershipAcquisitionNotification

